Index: issm/trunk/src/c/modules/ModelProcessorx/CreateNodes.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/CreateNodes.cpp	(revision 18081)
+++ issm/trunk/src/c/modules/ModelProcessorx/CreateNodes.cpp	(revision 18301)
@@ -13,5 +13,5 @@
 	/*Intermediaries*/
 	int   i,j,counter,vnodes,lid=0;
-	int   numberoffaces;
+	int   numberoffaces,elementnbv;
 	int   id0 = iomodel->nodecounter;
 	bool *my_faces = NULL;
@@ -162,4 +162,41 @@
 			}
 			break;
+		case P2bubbleEnum:
+			EdgesPartitioning(&my_edges,iomodel);
+			for(i=0;i<iomodel->numberofvertices;i++){
+				if(iomodel->my_vertices[i]){
+					nodes->AddObject(new Node(id0+i+1,i,lid++,i,iomodel,analysis,approximation));
+				}
+			}
+			for(i=0;i<iomodel->numberofedges;i++){
+				if(my_edges[i]){
+					nodes->AddObject(new Node(id0+iomodel->numberofvertices+i+1,iomodel->numberofvertices+i,lid++,0,iomodel,analysis,approximation));
+				}
+			}
+			id0 = id0+iomodel->numberofvertices+iomodel->numberofedges;
+			if(iomodel->meshelementtype==PentaEnum){
+				FacesPartitioning(&my_faces,iomodel);
+				for(i=0;i<iomodel->numberoffaces;i++){
+					if(iomodel->faces[i*iomodel->facescols+2]==2){/*Vertical quads*/
+						if(my_faces[i]){
+							node = new Node(id0+i+1,iomodel->numberofvertices+iomodel->numberofedges+i,lid++,0,iomodel,analysis,approximation);
+							nodes->AddObject(node);
+						}
+					}
+					else if(iomodel->faces[i*iomodel->facescols+2]==1){/*Triangular base/top*/
+						/*Nothing*/
+					}
+					else{
+						_error_("not supported");
+					}
+				}
+				id0 = id0+iomodel->numberoffaces;
+			}
+			for(i=0;i<iomodel->numberofelements;i++){
+				if(iomodel->my_elements[i]){
+					nodes->AddObject(new Node(id0+i+1,id0-iomodel->nodecounter+i,lid++,0,iomodel,analysis,approximation));
+				}
+			}
+			break;
 		case P2xP4Enum:
 			EdgesPartitioning(&my_edges,iomodel);
@@ -341,4 +378,39 @@
 			}
 			break;
+		case LATaylorHoodEnum:
+			_assert_(approximation==FSApproximationEnum);
+			/*P2 velocity*/
+			EdgesPartitioning(&my_edges,iomodel);
+			for(i=0;i<iomodel->numberofvertices;i++){
+				if(iomodel->my_vertices[i]){
+					nodes->AddObject(new Node(id0+i+1,i,lid++,i,iomodel,analysis,FSvelocityEnum));
+				}
+			}
+			for(i=0;i<iomodel->numberofedges;i++){
+				if(my_edges[i]){
+					nodes->AddObject(new Node(id0+iomodel->numberofvertices+i+1,iomodel->numberofvertices+i,lid++,0,iomodel,analysis,FSvelocityEnum));
+				}
+			}
+			id0 = id0+iomodel->numberofvertices+iomodel->numberofedges;
+	      if(iomodel->meshelementtype==PentaEnum){
+				FacesPartitioning(&my_faces,iomodel);
+				for(i=0;i<iomodel->numberoffaces;i++){
+					if(iomodel->faces[i*iomodel->facescols+2]==2){/*Vertical quads*/
+						if(my_faces[i]){
+							node = new Node(id0+i+1,iomodel->numberofvertices+iomodel->numberofedges+i,lid++,0,iomodel,analysis,FSvelocityEnum);
+							nodes->AddObject(node);
+						}
+					}
+					else if(iomodel->faces[i*iomodel->facescols+2]==1){/*Triangular base/top*/
+						/*Nothing*/
+					}
+					else{
+						_error_("not supported");
+					}
+				}
+			}
+
+			/*No pressure*/
+			break;
 		case OneLayerP4zEnum:
 			_assert_(approximation==FSApproximationEnum);
@@ -405,4 +477,60 @@
 			}
 			break;
+		case CrouzeixRaviartEnum:
+			_assert_(approximation==FSApproximationEnum);
+			/*P2b velocity*/
+			EdgesPartitioning(&my_edges,iomodel);
+			for(i=0;i<iomodel->numberofvertices;i++){
+				if(iomodel->my_vertices[i]){
+					nodes->AddObject(new Node(id0+i+1,i,lid++,i,iomodel,analysis,FSvelocityEnum));
+				}
+			}
+			for(i=0;i<iomodel->numberofedges;i++){
+				if(my_edges[i]){
+					nodes->AddObject(new Node(id0+iomodel->numberofvertices+i+1,iomodel->numberofvertices+i,lid++,0,iomodel,analysis,FSvelocityEnum));
+				}
+			}
+			id0 = id0+iomodel->numberofvertices+iomodel->numberofedges;
+			if(iomodel->meshelementtype==PentaEnum){
+				FacesPartitioning(&my_faces,iomodel);
+				for(i=0;i<iomodel->numberoffaces;i++){
+					if(iomodel->faces[i*iomodel->facescols+2]==2){/*Vertical quads*/
+						if(my_faces[i]){
+							node = new Node(id0+i+1,iomodel->numberofvertices+iomodel->numberofedges+i,lid++,0,iomodel,analysis,FSvelocityEnum);
+							nodes->AddObject(node);
+						}
+					}
+					else if(iomodel->faces[i*iomodel->facescols+2]==1){/*Triangular base/top*/
+						/*Nothing*/
+					}
+					else{
+						_error_("not supported");
+					}
+				}
+				id0 = id0+iomodel->numberoffaces;
+			}
+			for(i=0;i<iomodel->numberofelements;i++){
+				if(iomodel->my_elements[i]){
+					nodes->AddObject(new Node(id0+i+1,id0-iomodel->nodecounter+i,lid++,0,iomodel,analysis,FSvelocityEnum));
+				}
+			}
+
+			/*P1 DG pressure*/
+			vnodes = id0+iomodel->numberofelements;
+			switch(iomodel->meshelementtype){
+				case TriaEnum:  elementnbv = 3; break;
+				case TetraEnum: elementnbv = 4; break;
+				case PentaEnum: elementnbv = 6; break;
+				default:        _error_("mesh dimension not supported yet");
+			}
+			for(i=0;i<iomodel->numberofelements;i++){
+				if(iomodel->my_elements[i]){
+					for(j=0;j<elementnbv;j++){
+						nodes->AddObject(new Node(vnodes+elementnbv*i+j+1,vnodes-iomodel->nodecounter+elementnbv*i+j,lid++,iomodel->elements[+elementnbv*i+j]-1,iomodel,analysis,FSpressureEnum));
+
+					}
+				}
+			}
+			break;
 
 		default:
Index: issm/trunk/src/c/modules/ModelProcessorx/CreateParameters.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/CreateParameters.cpp	(revision 18081)
+++ issm/trunk/src/c/modules/ModelProcessorx/CreateParameters.cpp	(revision 18301)
@@ -19,5 +19,5 @@
 
 	int         i,j,m,k;
-	int         numoutputs,materialtype,smb_model;
+	int         numoutputs,materialtype,smb_model,basalforcing_model;
 	char**      requestedoutputs = NULL;
 	IssmDouble  time;
@@ -53,9 +53,9 @@
 	parameters->AddObject(iomodel->CopyConstantObject(TimesteppingTimeStepEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(TimesteppingCflCoefficientEnum));
+	parameters->AddObject(iomodel->CopyConstantObject(TimesteppingInterpForcingsEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(SettingsLowmemEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(DebugProfilingEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(MeshAverageVertexConnectivityEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(ConstantsReferencetemperatureEnum));
-	parameters->AddObject(iomodel->CopyConstantObject(GroundinglineMeltingRateEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(SettingsWaitonlockEnum));
 	parameters->AddObject(iomodel->CopyConstantObject(MeshNumberofelementsEnum));
@@ -123,6 +123,28 @@
 			/*Nothing to add to parameters*/
 			break;
+		case SMBcomponentsEnum:
+			/*Nothing to add to parameters*/
+			break;
+		case SMBmeltcomponentsEnum:
+			/*Nothing to add to parameters*/
+			break;
 		default:
 			_error_("Surface mass balance model "<<EnumToStringx(smb_model)<<" not supported yet");
+	}
+
+	/*Basal forcing parameters*/
+	parameters->AddObject(iomodel->CopyConstantObject(BasalforcingsEnum));
+	iomodel->Constant(&basalforcing_model,BasalforcingsEnum);
+	switch(basalforcing_model){
+		case FloatingMeltRateEnum:
+			/*Nothing to add to parameters*/
+			break;
+		case LinearFloatingMeltRateEnum:
+			parameters->AddObject(iomodel->CopyConstantObject(BasalforcingsDeepwaterMeltingRateEnum));
+			parameters->AddObject(iomodel->CopyConstantObject(BasalforcingsDeepwaterElevationEnum));
+			parameters->AddObject(iomodel->CopyConstantObject(BasalforcingsUpperwaterElevationEnum));
+			break;
+		default:
+			_error_("Basal forcing model "<<EnumToStringx(smb_model)<<" not supported yet");
 	}
 
Index: issm/trunk/src/c/modules/SetControlInputsFromVectorx/SetControlInputsFromVectorx.cpp
===================================================================
--- issm/trunk/src/c/modules/SetControlInputsFromVectorx/SetControlInputsFromVectorx.cpp	(revision 18081)
+++ issm/trunk/src/c/modules/SetControlInputsFromVectorx/SetControlInputsFromVectorx.cpp	(revision 18301)
@@ -7,5 +7,5 @@
 #include "../../toolkits/toolkits.h"
 
-void SetControlInputsFromVectorx(Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,IssmDouble* vector){
+void SetControlInputsFromVectorx(FemModel* femmodel,IssmDouble* vector){
 
 	int  num_controls;
@@ -13,10 +13,10 @@
 
 	/*Retrieve some parameters*/
-	parameters->FindParam(&num_controls,InversionNumControlParametersEnum);
-	parameters->FindParam(&control_type,NULL,InversionControlParametersEnum);
+	femmodel->parameters->FindParam(&num_controls,InversionNumControlParametersEnum);
+	femmodel->parameters->FindParam(&control_type,NULL,InversionControlParametersEnum);
 
 	for(int i=0;i<num_controls;i++){
-		for(int j=0;j<elements->Size();j++){
-			Element* element=(Element*)elements->GetObjectByOffset(j);
+		for(int j=0;j<femmodel->elements->Size();j++){
+			Element* element=(Element*)femmodel->elements->GetObjectByOffset(j);
 			element->SetControlInputsFromVector(vector,control_type[i],i);
 		}
@@ -26,13 +26,8 @@
 }
 
-void SetControlInputsFromVectorx(Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,Vector<IssmDouble>* vector){
+void SetControlInputsFromVectorx(FemModel* femmodel,Vector<IssmDouble>* vector){
 
-	IssmDouble* serial_vector=NULL;
-
-	serial_vector=vector->ToMPISerial();
-
-	SetControlInputsFromVectorx(elements,nodes, vertices, loads, materials, parameters,serial_vector);
-
-	/*Free ressources:*/
+	IssmDouble* serial_vector=vector->ToMPISerial();
+	SetControlInputsFromVectorx(femmodel,serial_vector);
 	xDelete<IssmDouble>(serial_vector);
 }
Index: issm/trunk/src/c/modules/SetControlInputsFromVectorx/SetControlInputsFromVectorx.h
===================================================================
--- issm/trunk/src/c/modules/SetControlInputsFromVectorx/SetControlInputsFromVectorx.h	(revision 18081)
+++ issm/trunk/src/c/modules/SetControlInputsFromVectorx/SetControlInputsFromVectorx.h	(revision 18301)
@@ -8,6 +8,6 @@
 
 /* local prototypes: */
-void SetControlInputsFromVectorx(Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,Vector<IssmDouble>* vector);
-void SetControlInputsFromVectorx(Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,IssmDouble* vector);
+void SetControlInputsFromVectorx(FemModel* femmodel,Vector<IssmDouble>* vector);
+void SetControlInputsFromVectorx(FemModel* femmodel,IssmDouble* vector);
 
 #endif 
Index: issm/trunk/src/c/modules/SurfaceMassBalancex/SurfaceMassBalancex.cpp
===================================================================
--- issm/trunk/src/c/modules/SurfaceMassBalancex/SurfaceMassBalancex.cpp	(revision 18081)
+++ issm/trunk/src/c/modules/SurfaceMassBalancex/SurfaceMassBalancex.cpp	(revision 18301)
@@ -38,4 +38,12 @@
 			SmbHenningx(femmodel);
 			break;
+		case SMBcomponentsEnum:
+			if(VerboseSolution())_printf_("  call smb Components module\n");
+			SmbComponentsx(femmodel);
+			break;
+		case SMBmeltcomponentsEnum:
+			if(VerboseSolution())_printf_("  call smb Melt Components module\n");
+			SmbMeltComponentsx(femmodel);
+			break;
 		default:
 			_error_("Surface mass balance model "<<EnumToStringx(smb_model)<<" not supported yet");
@@ -50,8 +58,53 @@
 	//    INPUT: surface elevation (m): hd(NA)
 	//    OUTPUT: mass-balance (m/yr ice): agd(NA)
-
-	for(int i=0;i<femmodel->elements->Size();i++){
-		Element* element=dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
-		element->SmbGradients();
+	int v;
+	IssmDouble rho_water;                   // density of fresh water
+	IssmDouble rho_ice;                     // density of ice
+
+	/*Loop over all the elements of this partition*/
+	for(int i=0;i<femmodel->elements->Size();i++){
+		Element* element=dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
+
+		/*Allocate all arrays*/
+		int         numvertices = element->GetNumberOfVertices();
+		IssmDouble* Href        = xNew<IssmDouble>(numvertices); // reference elevation from which deviations are used to calculate the SMB adjustment
+		IssmDouble* Smbref      = xNew<IssmDouble>(numvertices); // reference SMB to which deviations are added
+		IssmDouble* b_pos       = xNew<IssmDouble>(numvertices); // Hs-SMB relation parameter
+		IssmDouble* b_neg       = xNew<IssmDouble>(numvertices); // Hs-SMB relation paremeter
+		IssmDouble* s           = xNew<IssmDouble>(numvertices); // surface elevation (m)
+		IssmDouble* smb         = xNew<IssmDouble>(numvertices);
+
+		/*Recover SmbGradients*/
+		element->GetInputListOnVertices(Href,SurfaceforcingsHrefEnum);
+		element->GetInputListOnVertices(Smbref,SurfaceforcingsSmbrefEnum);
+		element->GetInputListOnVertices(b_pos,SurfaceforcingsBPosEnum);
+		element->GetInputListOnVertices(b_neg,SurfaceforcingsBNegEnum);
+
+		/*Recover surface elevation at vertices: */
+		element->GetInputListOnVertices(s,SurfaceEnum);
+
+		/*Get material parameters :*/
+		rho_ice=element->matpar->GetRhoIce();
+		rho_water=element->matpar->GetRhoFreshwater();
+
+		// loop over all vertices
+		for(v=0;v<numvertices;v++){
+			if(Smbref[v]>0){
+				smb[v]=Smbref[v]+b_pos[v]*(s[v]-Href[v]);
+			}
+			else{
+				smb[v]=Smbref[v]+b_neg[v]*(s[v]-Href[v]);
+			}
+			smb[v]=smb[v]/1000*rho_water/rho_ice;      // SMB in m/y ice
+		}  //end of the loop over the vertices
+
+		/*Add input to element and Free memory*/
+		element->AddInput(SurfaceforcingsMassBalanceEnum,smb,P1Enum);
+		xDelete<IssmDouble>(Href);
+		xDelete<IssmDouble>(Smbref);
+		xDelete<IssmDouble>(b_pos);
+		xDelete<IssmDouble>(b_neg);
+		xDelete<IssmDouble>(s);
+		xDelete<IssmDouble>(smb);
 	}
 
@@ -227,2 +280,86 @@
 
 }/*}}}*/
+void SmbComponentsx(FemModel* femmodel){/*{{{*/
+
+	// void SmbComponentsx(acc,evap,runoff,ni){
+	//    INPUT parameters: ni: working size of arrays
+	//    INPUT: surface accumulation (m/yr water equivalent): acc
+	//    surface evaporation (m/yr water equivalent): evap
+	//    surface runoff (m/yr water equivalent): runoff
+	//    OUTPUT: mass-balance (m/yr ice): agd(NA)
+	int v;
+
+	/*Loop over all the elements of this partition*/
+	for(int i=0;i<femmodel->elements->Size();i++){
+		Element* element=dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
+
+		/*Allocate all arrays*/
+		int         numvertices = element->GetNumberOfVertices();
+		IssmDouble* acc         = xNew<IssmDouble>(numvertices); 
+		IssmDouble* evap        = xNew<IssmDouble>(numvertices);
+		IssmDouble* runoff      = xNew<IssmDouble>(numvertices); 
+		IssmDouble* smb         = xNew<IssmDouble>(numvertices);
+
+		/*Recover Smb Components*/
+		element->GetInputListOnVertices(acc,SurfaceforcingsAccumulationEnum);
+		element->GetInputListOnVertices(evap,SurfaceforcingsEvaporationEnum);
+		element->GetInputListOnVertices(runoff,SurfaceforcingsRunoffEnum);
+
+		// loop over all vertices
+		for(v=0;v<numvertices;v++){
+			smb[v]=acc[v]-evap[v]-runoff[v];
+		}  //end of the loop over the vertices
+
+		/*Add input to element and Free memory*/
+		element->AddInput(SurfaceforcingsMassBalanceEnum,smb,P1Enum);
+		xDelete<IssmDouble>(acc);
+		xDelete<IssmDouble>(evap);
+		xDelete<IssmDouble>(runoff);
+		xDelete<IssmDouble>(smb);
+	}
+
+}/*}}}*/
+void SmbMeltComponentsx(FemModel* femmodel){/*{{{*/
+
+	// void SmbMeltComponentsx(acc,evap,melt,refreeze,ni){
+	//    INPUT parameters: ni: working size of arrays
+	//    INPUT: surface accumulation (m/yr water equivalent): acc
+	//    surface evaporation (m/yr water equivalent): evap
+	//    surface melt (m/yr water equivalent): melt
+	//    refreeze of surface melt (m/yr water equivalent): refreeze
+	//    OUTPUT: mass-balance (m/yr ice): agd(NA)
+	int v;
+
+	/*Loop over all the elements of this partition*/
+	for(int i=0;i<femmodel->elements->Size();i++){
+		Element* element=dynamic_cast<Element*>(femmodel->elements->GetObjectByOffset(i));
+
+		/*Allocate all arrays*/
+		int         numvertices = element->GetNumberOfVertices();
+		IssmDouble* acc         = xNew<IssmDouble>(numvertices);
+		IssmDouble* evap        = xNew<IssmDouble>(numvertices); 
+		IssmDouble* melt        = xNew<IssmDouble>(numvertices);
+		IssmDouble* refreeze    = xNew<IssmDouble>(numvertices);
+		IssmDouble* smb         = xNew<IssmDouble>(numvertices);
+
+		/*Recover Smb Components*/
+		element->GetInputListOnVertices(acc,SurfaceforcingsAccumulationEnum);
+		element->GetInputListOnVertices(evap,SurfaceforcingsEvaporationEnum);
+		element->GetInputListOnVertices(melt,SurfaceforcingsMeltEnum);
+		element->GetInputListOnVertices(refreeze,SurfaceforcingsRefreezeEnum);
+
+		// loop over all vertices
+		for(v=0;v<numvertices;v++){
+			smb[v]=acc[v]-evap[v]-melt[v]+refreeze[v];
+		}  //end of the loop over the vertices
+
+		/*Add input to element and Free memory*/
+		element->AddInput(SurfaceforcingsMassBalanceEnum,smb,P1Enum);
+		xDelete<IssmDouble>(acc);
+		xDelete<IssmDouble>(evap);
+		xDelete<IssmDouble>(melt);
+		xDelete<IssmDouble>(refreeze);
+		xDelete<IssmDouble>(smb);
+	}
+
+}/*}}}*/
Index: issm/trunk/src/c/modules/SurfaceMassBalancex/SurfaceMassBalancex.h
===================================================================
--- issm/trunk/src/c/modules/SurfaceMassBalancex/SurfaceMassBalancex.h	(revision 18081)
+++ issm/trunk/src/c/modules/SurfaceMassBalancex/SurfaceMassBalancex.h	(revision 18301)
@@ -14,4 +14,6 @@
 void PositiveDegreeDayx(FemModel* femmodel);
 void SmbHenningx(FemModel* femmodel);
+void SmbComponentsx(FemModel* femmodel);
+void SmbMeltComponentsx(FemModel* femmodel);
 
 #endif  /* _SurfaceMassBalancex_H*/
Index: issm/trunk/src/c/modules/modules.h
===================================================================
--- issm/trunk/src/c/modules/modules.h	(revision 18081)
+++ issm/trunk/src/c/modules/modules.h	(revision 18301)
@@ -8,5 +8,4 @@
 /*Modules: */
 #include "./AllocateSystemMatricesx/AllocateSystemMatricesx.h"
-#include "./AverageFilterx/AverageFilterx.h"
 #include "./AverageOntoPartitionx/AverageOntoPartitionx.h"
 #include "./Bamgx/Bamgx.h"
@@ -17,12 +16,9 @@
 #include "./ContourToMeshx/ContourToMeshx.h"
 #include "./ContourToNodesx/ContourToNodesx.h"
-#include "./ControlInputGetGradientx/ControlInputGetGradientx.h"
 #include "./ControlInputSetGradientx/ControlInputSetGradientx.h"
-#include "./ControlInputScaleGradientx/ControlInputScaleGradientx.h"
 #include "./CreateNodalConstraintsx/CreateNodalConstraintsx.h"
 #include "./CreateJacobianMatrixx/CreateJacobianMatrixx.h"
 #include "./DragCoefficientAbsGradientx/DragCoefficientAbsGradientx.h"
 #include "./ElementConnectivityx/ElementConnectivityx.h"
-#include "./EdgeDetectionx/EdgeDetectionx.h"
 #include "./GetSolutionFromInputsx/GetSolutionFromInputsx.h"
 #include "./GetVectorFromInputsx/GetVectorFromInputsx.h"
@@ -33,5 +29,4 @@
 #include "./Gradjx/Gradjx.h"
 #include "./GroundinglineMigrationx/GroundinglineMigrationx.h"
-#include "./HoleFillerx/HoleFillerx.h"
 #include "./InputControlUpdatex/InputControlUpdatex.h"
 #include "./InputDepthAverageAtBasex/InputDepthAverageAtBasex.h"
@@ -57,4 +52,5 @@
 #include "./Kml2Expx/Kml2Expx.h"
 #include "./Krigingx/Krigingx.h"
+#include "./FloatingiceMeltingRatex/FloatingiceMeltingRatex.h"
 #include "./Mergesolutionfromftogx/Mergesolutionfromftogx.h"
 #include "./MeshPartitionx/MeshPartitionx.h"
@@ -70,5 +66,4 @@
 #include "./NodeConnectivityx/NodeConnectivityx.h"
 #include "./NodesDofx/NodesDofx.h"
-#include "./Orthx/Orthx.h"
 #include "./OutputDefinitionsResponsex/OutputDefinitionsResponsex.h"
 #include "./OutputResultsx/OutputResultsx.h"
Index: issm/trunk/src/c/shared/Elements/DrainageFunctionWaterfraction.cpp
===================================================================
--- issm/trunk/src/c/shared/Elements/DrainageFunctionWaterfraction.cpp	(revision 18081)
+++ issm/trunk/src/c/shared/Elements/DrainageFunctionWaterfraction.cpp	(revision 18301)
@@ -7,5 +7,4 @@
 #include "../Exceptions/exceptions.h"
 
-/*FUNCTION IssmDouble DrainageFunctionWaterfraction()*/
 IssmDouble DrainageFunctionWaterfraction(IssmDouble waterfraction, IssmDouble dt=0.){
 	/* DrainageFunctionWaterfraction returns how much of the waterfraction is drained per year */
Index: issm/trunk/src/c/shared/Enum/EnumDefinitions.h
===================================================================
--- issm/trunk/src/c/shared/Enum/EnumDefinitions.h	(revision 18081)
+++ issm/trunk/src/c/shared/Enum/EnumDefinitions.h	(revision 18301)
@@ -38,7 +38,13 @@
 	BalancethicknessStabilizationEnum,
 	BalancethicknessThickeningRateEnum,
+	BasalforcingsEnum,
 	BasalforcingsGeothermalfluxEnum,
-	BasalforcingsMeltingRateCorrectionEnum,
-	BasalforcingsMeltingRateEnum,
+	BasalforcingsGroundediceMeltingRateEnum,
+	BasalforcingsFloatingiceMeltingRateEnum,
+	BasalforcingsDeepwaterMeltingRateEnum,
+	BasalforcingsDeepwaterElevationEnum,
+	BasalforcingsUpperwaterElevationEnum,
+	FloatingMeltRateEnum,
+	LinearFloatingMeltRateEnum,
 	BedEnum,
 	BaseEnum,
@@ -161,5 +167,4 @@
 	InversionVzObsEnum,
 	MaskIceLevelsetEnum,
-	QmuMaskIceLevelsetEnum,
 	MaterialsBetaEnum,
 	MaterialsHeatcapacityEnum,
@@ -174,5 +179,4 @@
 	DamageDEnum,
 	DamageFEnum,
-	QmuDamageDEnum,
 	DamageDbarEnum,
 	DamageLawEnum,
@@ -194,4 +198,5 @@
 	DamageEvolutionNumRequestedOutputsEnum,
 	DamageEvolutionRequestedOutputsEnum,
+	NewDamageEnum,
 	MaterialsRhoIceEnum,
 	MaterialsRhoSeawaterEnum,
@@ -247,5 +252,4 @@
 	QmuResponsedescriptorsEnum,
 	QmuVariabledescriptorsEnum,
-	QmuMaterialsRheologyBEnum,
 	RiftsNumriftsEnum,
 	RiftsRiftstructEnum,
@@ -324,4 +328,11 @@
 	SurfaceforcingsBNegEnum,
 	SMBhenningEnum,
+	SMBcomponentsEnum,
+	SurfaceforcingsAccumulationEnum,
+	SurfaceforcingsEvaporationEnum,
+	SurfaceforcingsRunoffEnum,
+	SMBmeltcomponentsEnum,
+	SurfaceforcingsMeltEnum,
+	SurfaceforcingsRefreezeEnum,
 	/*TO BE REMOVED*/
 	SurfaceforcingsIspddEnum,
@@ -377,4 +388,5 @@
 	ThermalSolutionEnum,
 	TransientSolutionEnum,
+	UzawaPressureAnalysisEnum,
 	GiaSolutionEnum,
 	GiaAnalysisEnum,
@@ -492,5 +504,4 @@
 	FractionIncrementEnum,
 	FrictionEnum,
-	GroundinglineMeltingRateEnum,
 	InternalEnum,
 	MassFluxEnum,
@@ -499,15 +510,4 @@
 	PressureEnum,
 	PressurePicardEnum,
-	QmuPressureEnum,
-	QmuVxEnum,
-	QmuVyEnum,
-	QmuVzEnum,
-	QmuThicknessEnum,
-	QmuBaseEnum,
-	QmuSurfaceEnum,
-	QmuMeltingEnum,
-	QmuVxMeshEnum,
-	QmuVyMeshEnum,
-	QmuVzMeshEnum,
 	AndroidFrictionCoefficientEnum,
 	ResetPenaltiesEnum,
@@ -553,5 +553,4 @@
 	BasalFrictionEnum,
 	ViscousHeatingEnum,
-	QmuTemperatureEnum,
 	HydrologyWaterVxEnum,
 	HydrologyWaterVyEnum,
@@ -590,4 +589,6 @@
 	P1bubblecondensedEnum,
 	P2Enum,
+	P2bubbleEnum,
+	P2bubblecondensedEnum,
 	P2xP1Enum,
 	P1xP2Enum,
@@ -599,6 +600,8 @@
 	MINIcondensedEnum,
 	TaylorHoodEnum,
+	LATaylorHoodEnum,
 	XTaylorHoodEnum,
 	OneLayerP4zEnum,
+	CrouzeixRaviartEnum,
 	/*}}}*/
 	/*Results{{{*/
@@ -650,4 +653,7 @@
 	IncrementalEnum,
 	AugmentedLagrangianREnum,
+	AugmentedLagrangianRhopEnum,
+	AugmentedLagrangianRlambdaEnum,
+	AugmentedLagrangianRholambdaEnum,
 	AugmentedLagrangianThetaEnum,
 	/*}}}*/
@@ -660,5 +666,4 @@
 	ContactEnum,
 	MaskGroundediceLevelsetEnum,
-	QmuMaskGroundediceLevelsetEnum,
 	/*}}}*/
 	/*Gauss{{{*/
Index: issm/trunk/src/c/shared/Enum/EnumToStringx.cpp
===================================================================
--- issm/trunk/src/c/shared/Enum/EnumToStringx.cpp	(revision 18081)
+++ issm/trunk/src/c/shared/Enum/EnumToStringx.cpp	(revision 18301)
@@ -46,7 +46,13 @@
 		case BalancethicknessStabilizationEnum : return "BalancethicknessStabilization";
 		case BalancethicknessThickeningRateEnum : return "BalancethicknessThickeningRate";
+		case BasalforcingsEnum : return "Basalforcings";
 		case BasalforcingsGeothermalfluxEnum : return "BasalforcingsGeothermalflux";
-		case BasalforcingsMeltingRateCorrectionEnum : return "BasalforcingsMeltingRateCorrection";
-		case BasalforcingsMeltingRateEnum : return "BasalforcingsMeltingRate";
+		case BasalforcingsGroundediceMeltingRateEnum : return "BasalforcingsGroundediceMeltingRate";
+		case BasalforcingsFloatingiceMeltingRateEnum : return "BasalforcingsFloatingiceMeltingRate";
+		case BasalforcingsDeepwaterMeltingRateEnum : return "BasalforcingsDeepwaterMeltingRate";
+		case BasalforcingsDeepwaterElevationEnum : return "BasalforcingsDeepwaterElevation";
+		case BasalforcingsUpperwaterElevationEnum : return "BasalforcingsUpperwaterElevation";
+		case FloatingMeltRateEnum : return "FloatingMeltRate";
+		case LinearFloatingMeltRateEnum : return "LinearFloatingMeltRate";
 		case BedEnum : return "Bed";
 		case BaseEnum : return "Base";
@@ -169,5 +175,4 @@
 		case InversionVzObsEnum : return "InversionVzObs";
 		case MaskIceLevelsetEnum : return "MaskIceLevelset";
-		case QmuMaskIceLevelsetEnum : return "QmuMaskIceLevelset";
 		case MaterialsBetaEnum : return "MaterialsBeta";
 		case MaterialsHeatcapacityEnum : return "MaterialsHeatcapacity";
@@ -182,5 +187,4 @@
 		case DamageDEnum : return "DamageD";
 		case DamageFEnum : return "DamageF";
-		case QmuDamageDEnum : return "QmuDamageD";
 		case DamageDbarEnum : return "DamageDbar";
 		case DamageLawEnum : return "DamageLaw";
@@ -202,4 +206,5 @@
 		case DamageEvolutionNumRequestedOutputsEnum : return "DamageEvolutionNumRequestedOutputs";
 		case DamageEvolutionRequestedOutputsEnum : return "DamageEvolutionRequestedOutputs";
+		case NewDamageEnum : return "NewDamage";
 		case MaterialsRhoIceEnum : return "MaterialsRhoIce";
 		case MaterialsRhoSeawaterEnum : return "MaterialsRhoSeawater";
@@ -255,5 +260,4 @@
 		case QmuResponsedescriptorsEnum : return "QmuResponsedescriptors";
 		case QmuVariabledescriptorsEnum : return "QmuVariabledescriptors";
-		case QmuMaterialsRheologyBEnum : return "QmuMaterialsRheologyB";
 		case RiftsNumriftsEnum : return "RiftsNumrifts";
 		case RiftsRiftstructEnum : return "RiftsRiftstruct";
@@ -330,4 +334,11 @@
 		case SurfaceforcingsBNegEnum : return "SurfaceforcingsBNeg";
 		case SMBhenningEnum : return "SMBhenning";
+		case SMBcomponentsEnum : return "SMBcomponents";
+		case SurfaceforcingsAccumulationEnum : return "SurfaceforcingsAccumulation";
+		case SurfaceforcingsEvaporationEnum : return "SurfaceforcingsEvaporation";
+		case SurfaceforcingsRunoffEnum : return "SurfaceforcingsRunoff";
+		case SMBmeltcomponentsEnum : return "SMBmeltcomponents";
+		case SurfaceforcingsMeltEnum : return "SurfaceforcingsMelt";
+		case SurfaceforcingsRefreezeEnum : return "SurfaceforcingsRefreeze";
 		case SurfaceforcingsIspddEnum : return "SurfaceforcingsIspdd";
 		case SurfaceforcingsIssmbgradientsEnum : return "SurfaceforcingsIssmbgradients";
@@ -380,4 +391,5 @@
 		case ThermalSolutionEnum : return "ThermalSolution";
 		case TransientSolutionEnum : return "TransientSolution";
+		case UzawaPressureAnalysisEnum : return "UzawaPressureAnalysis";
 		case GiaSolutionEnum : return "GiaSolution";
 		case GiaAnalysisEnum : return "GiaAnalysis";
@@ -483,5 +495,4 @@
 		case FractionIncrementEnum : return "FractionIncrement";
 		case FrictionEnum : return "Friction";
-		case GroundinglineMeltingRateEnum : return "GroundinglineMeltingRate";
 		case InternalEnum : return "Internal";
 		case MassFluxEnum : return "MassFlux";
@@ -490,15 +501,4 @@
 		case PressureEnum : return "Pressure";
 		case PressurePicardEnum : return "PressurePicard";
-		case QmuPressureEnum : return "QmuPressure";
-		case QmuVxEnum : return "QmuVx";
-		case QmuVyEnum : return "QmuVy";
-		case QmuVzEnum : return "QmuVz";
-		case QmuThicknessEnum : return "QmuThickness";
-		case QmuBaseEnum : return "QmuBase";
-		case QmuSurfaceEnum : return "QmuSurface";
-		case QmuMeltingEnum : return "QmuMelting";
-		case QmuVxMeshEnum : return "QmuVxMesh";
-		case QmuVyMeshEnum : return "QmuVyMesh";
-		case QmuVzMeshEnum : return "QmuVzMesh";
 		case AndroidFrictionCoefficientEnum : return "AndroidFrictionCoefficient";
 		case ResetPenaltiesEnum : return "ResetPenalties";
@@ -544,5 +544,4 @@
 		case BasalFrictionEnum : return "BasalFriction";
 		case ViscousHeatingEnum : return "ViscousHeating";
-		case QmuTemperatureEnum : return "QmuTemperature";
 		case HydrologyWaterVxEnum : return "HydrologyWaterVx";
 		case HydrologyWaterVyEnum : return "HydrologyWaterVy";
@@ -579,4 +578,6 @@
 		case P1bubblecondensedEnum : return "P1bubblecondensed";
 		case P2Enum : return "P2";
+		case P2bubbleEnum : return "P2bubble";
+		case P2bubblecondensedEnum : return "P2bubblecondensed";
 		case P2xP1Enum : return "P2xP1";
 		case P1xP2Enum : return "P1xP2";
@@ -588,6 +589,8 @@
 		case MINIcondensedEnum : return "MINIcondensed";
 		case TaylorHoodEnum : return "TaylorHood";
+		case LATaylorHoodEnum : return "LATaylorHood";
 		case XTaylorHoodEnum : return "XTaylorHood";
 		case OneLayerP4zEnum : return "OneLayerP4z";
+		case CrouzeixRaviartEnum : return "CrouzeixRaviart";
 		case SaveResultsEnum : return "SaveResults";
 		case BoolExternalResultEnum : return "BoolExternalResult";
@@ -631,4 +634,7 @@
 		case IncrementalEnum : return "Incremental";
 		case AugmentedLagrangianREnum : return "AugmentedLagrangianR";
+		case AugmentedLagrangianRhopEnum : return "AugmentedLagrangianRhop";
+		case AugmentedLagrangianRlambdaEnum : return "AugmentedLagrangianRlambda";
+		case AugmentedLagrangianRholambdaEnum : return "AugmentedLagrangianRholambda";
 		case AugmentedLagrangianThetaEnum : return "AugmentedLagrangianTheta";
 		case NoneEnum : return "None";
@@ -639,5 +645,4 @@
 		case ContactEnum : return "Contact";
 		case MaskGroundediceLevelsetEnum : return "MaskGroundediceLevelset";
-		case QmuMaskGroundediceLevelsetEnum : return "QmuMaskGroundediceLevelset";
 		case GaussSegEnum : return "GaussSeg";
 		case GaussTriaEnum : return "GaussTria";
